// $Id$

//=============================================================================
/**
 *  @file  parameter.h
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *  Copyright (C) 2003-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_PARAMETER_H
#define JYUGEM_BEE_PARAMETER_H

#include "jyugem/bee.h"

namespace jyugem { namespace bee
{

class value;

//
// Interface class
//
struct BEE_Export parameter : public nameable
{
  parameter() : nameable(_TX("")) {}
  parameter(const string& name) : nameable(name) {}
  parameter(const string& name, const value& v)
    : nameable(name), m_value(v) {}
  parameter(const parameter& rhs) : nameable(rhs), m_value(rhs.m_value) {}
  ~parameter() {}

  parameter& operator=(const parameter& rhs)
  {
    if (this == &rhs)
      return *this;
    m_uniqueName = rhs.m_uniqueName;
    m_value = rhs.m_value;
    return *this;
  }

  const std::string& name() { return this->uniqueName(); }
  const bee::value& value() const { return m_value; }
  const bee::value  get() const   { return m_value; }
  int   set(const bee::value& v)  { m_value = v; return 0; }

protected:
  bee::value m_value;
};


} } // *namespace*

#endif
