// $Id$

//=============================================================================
/**
 *  @file    FrontEndModule.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_CMS_FRONTENDMODULE_H
#define JYUGEM_CMS_FRONTENDMODULE_H

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif


#include <boost/mpl/list.hpp>
#include <boost/format.hpp>

#include "jyugem/cms/CarrierHandler.h"
#include "jyugem/bee/state_task.h"
namespace bee = jyugem::bee;


//
namespace jyugem { namespace cms
{

class Carrier;
class LoadPort;

//-----------------------------------------------------------------------------
//
// E87 : SPECIFICATION FOR CARRIER MANAGEMENT
//
//       Front End Module class
//
//-----------------------------------------------------------------------------
class FrontEndModule
{
    friend class LoadPortGroup;

public:
    FrontEndModule();
//  FrontEndModule(const FrontEndModule& rhs) { this->copy(rhs); }
    virtual ~FrontEndModule() {}

//  FrontEndModule& operator=(const FrontEndModule& rhs)
//  {
//      if ( this== &rhs)
//          return *this;
//      this->copy(rhs);
//      return *this;
//  }

    int open();

    LoadPortPtr loadport(int pnum) { return m_carrier_handler.loadport(pnum); }

protected:
//  void copy(const FrontEndModule& rhs);

protected:
    CarrierHandler m_carrier_handler;
};

} } // *namespace* jyugem::cms

#endif
