// $Id$

//=============================================================================
/**
 *  @file  state_task.cpp
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 1998-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#include "jyugem/bee/state_machine_task.h"
#include "jyugem/bee/state_task.h"
using namespace jyugem::bee;

namespace jyugem { namespace bee
{

int state_task::update(const std::string& evtname)
{
    bee::trigger * trig = new bee::trigger(evtname);
    int result = this->notify(trig, null);

//    ACE_OS::sleep(1);

    return result;
}

//
// Service thread.
//
int state_task::svc(void)
{
  TRACE_FUNCTION();
  // TRACE_DEBUG((_TX("%s start.\n"), this->name_p()));

  int  result = 0;

  // Receive trigger request.
  for (;;)
  {
    auto_ptr<trigger_request> mo(static_cast<trigger_request *>(
                    this->m_activation_queue.dequeue()));
    // Call it.
    if ((result = mo->call()) == -1)
    {
      break;
    }

    // Call boost::fsm.
    if (m_status != null)
    {
      m_status->send(mo->get_trigger());
    }

    ACE_OS::sleep(1);

    // Destructor automatically deletes it.
  }

  if (result == -1 && errno == EWOULDBLOCK)
  {
    TRACE_ERROR((_TX("(%s) %p\n"), this->name_p(),
           _TX("timed out waiting for message")));
  }

  TRACE_DEBUG((_TX("%s end.\n"), this->name_p()));
  return 0;
}


} }  // *namespace* - jyugem::bee
